> For the complete documentation index, see [llms.txt](https://docs.echo3d.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.echo3d.com/api/download.md).

# Download

## Download file via Storage ID

<mark style="color:blue;">`GET`</mark> `https://api.echo3D.com/query?key=<API_KEY>&email=<EMAIL>&userKey=<USER_KEY>&file=<FILE_STORAGE_ID>`

This query allows you to download a file stored in the system. Asset file storage IDs can be obtained by querying the asset data as shown in the [Queries](/api/queries.md) section.&#x20;

#### Query Parameters

| Name                                      | Type   | Description                                                                                                                             |
| ----------------------------------------- | ------ | --------------------------------------------------------------------------------------------------------------------------------------- |
| key<mark style="color:red;">\*</mark>     | string | Your API key.                                                                                                                           |
| file<mark style="color:red;">\*</mark>    | string | The file storage ID.                                                                                                                    |
| email<mark style="color:red;">\*</mark>   | string | Your email address                                                                                                                      |
| userKey<mark style="color:red;">\*</mark> | string | Your authentication key                                                                                                                 |
| secKey                                    | string | Your Secret key. Only if enabled through the [Security page](/web-console/manage-pages/collections-and-sharing/security.md#secret-key). |

{% tabs %}
{% tab title="200 The file will start downloading." %}

```
N/A
```

{% endtab %}
{% endtabs %}

## Download specific file format for an entry

<mark style="color:blue;">`POST`</mark>`https://api.echo3D.com/download`

This query allows you to download a file of a specified format for a given asset. If the format for an asset does not exist, the request can optionally trigger the conversion and wait for the system to generate and return the file in the requested format.&#x20;

#### Request Parameters

All parameters must be included as form data with matching content type header `Content-Type: application/x-www-form-urlencoded`

<table><thead><tr><th width="172">Name</th><th width="132">Type</th><th>Description</th></tr></thead><tbody><tr><td>key<mark style="color:red;">*</mark></td><td>string</td><td>Your API key.</td></tr><tr><td>entryId<mark style="color:red;">*</mark></td><td>string</td><td>Asset's entry id</td></tr><tr><td>email<mark style="color:red;">*</mark></td><td>string</td><td>Your email</td></tr><tr><td>userKey<mark style="color:red;">*</mark></td><td>string</td><td>Your authentication key</td></tr><tr><td>secKey</td><td>string</td><td>Your Secret key. Only if enabled through the <a href="/pages/-M41x3tGykQ1P8zc6MV_#secret-key">Security page</a>.</td></tr><tr><td>fileFormat</td><td>string</td><td>Target file format version of the you would like to download. Request may be rejected if the target asset does not support the conversion (eg, requesting a <code>glb</code> for a <code>pdf</code> asset). Omit this parameter to download the original version of the asset uploaded. Example: <code>glb</code> </td></tr><tr><td>convertMissing</td><td>string</td><td>Set to "true" to attempt to convert the file if the target format version does not already exist. Note that the converted files will count for storage and bandwidth used in your subscription. The API will wait for the conversion to finish to respond. Conversion times can be long (>5m) for large or complex models.</td></tr></tbody></table>

{% tabs %}
{% tab title="302: The file will start downloading" %}

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.echo3d.com/api/download.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
